/** cross platform shell commands.  not promise based unfortunately  */
import shelljs = require("shelljs");
/** ask a question on the console, and awaits a typed answer (followed by the ```ENTER``` key) */
export declare function question(query: string, options?: {
    defaultIfBlank?: string;
    forceLowercase?: boolean;
}): Promise<string>;
/** bare-bones question prompt. as this isn't very user friendly, generally you should NOT use this directly.  instead use ```askQuestion()``` or ```askQuestionChoices()``` */
export declare function __question(query: string): Promise<string>;
/** ask a question, offering explicit choices the user can select from.   default choices are [y,n] with no blank options allowed. */
export declare function questionChoices(query: string, options?: {
    choices?: string[];
    defaultIfBlank?: string | number;
    preserveCase?: boolean;
    numericSelect?: boolean;
}): Promise<string>;
/** execute a command to the native shell */
export declare function exec(cmd: string, options?: {
    /** what exitCode to expect (default 0)   if this code isn't recieved, an error is thrown.   set to ```null``` to ignore */
    exitCode?: number;
    shellOptions?: shelljs.ExecOptions;
}): Promise<{
    shellCmd: string;
    code: number;
    stdout: string;
    stderr: string;
}>;
/** write a section (heading) to console.out */
export declare function section(...args: any[]): void;
/** write a comment (minor text) to console.out */
export declare function comment(...args: any[]): void;
/** write plain text to console.out */
export declare function echo(...args: any[]): void;
//# sourceMappingURL=shell.d.ts.map